local addOnName = ...
--two amazing websites for doing this
--https://wow.tools/files/#search=&page=1&sort=0&desc=asc
--https://wow.tools/dbc/?dbc=soundkitentry&build=8.3.0.32489#search=&page=1

--SAVED VARIABLES
--holds the initial states for all the buttons, true by default as hard coded in, on addon reload it updates this list when all variables are loaded
madness_whisperStates = {
	["yoggState"] = true,
	["cthunState"] = true,
	["yshaarjState"] = true,
	["voidState"] = true,
	["xalatathstate"] = true,
}
--madness_Timer for the whispers
madness_Timer = 120 -- interval in seconds
------------- SOUND LIBRARY SETUP ------------------------------------------------------

--Sound libraries, loose varients have the audio file numbers and not the audio file pathways.
local yoggSounds = {
	564858,
	564838,
	564877,
	564865,
	564834,
	564862,
	564868,
	564857,
	564870,
	564856,
	564845,
	564823,
	564859,
	564853,
	564876,
	564841,
	564824,
	564860,
	564822,
	564832,
	564844,
	564835,
	564839,
	564846,
	564871,

	568638,
	568698,
	569371,
	569588,
}

local CThunSounds = {
	546627,
	546621,
	546623,
	546633,
	546626,
	546620,
	546636,
	546628,

	546625,

	546631,
	546632,
	546629,

	546624,
	546637,
	546634,
	546635,
}

local yShaarjsounds = {
	851840,
	851836,
	851838,
	851832,
	851830,
	901525,
	901523,
	901527,
	851844,
	851842,

	901535,
	901533,
	901531,
	901529,

	901537,
	901541,
	901539,
	901543,
	901545,
	901547,
	901549,
	901551,
	901553,
	901569,

	901571,
	901567,
	901565,
	901563,
	901561,
	901559,
	901557,
	901555,
}
--639530

--639528 I am the hunger of the void
local voidSounds = {
	1385178,

	1385201,

	1385211,

	1385223,

	1385212,

	639502,
	639504,
	639506,
	639508,

	639516,
	639514,
	639512,
	639510,

	639526,
	639528,
	639530,

	595295,

	595307,

	595316,

	595244,
	595235,
}

local XalatathSounds = {
	1391136,
	1391143,
	1391156,
	1391157,
	1391167,
	1391173,
	1391180,
	1391189,
	1391194,
	1391195,
	1580993,
	1581002,
	1581003,
	1581004,
	1581005,
	1581006,
	1686159,
	1686164,
	1686320,
	1686323,
	2530793,
	2530794,
	2530795,
	2530797,
	2530798,
	2530803,
	2530807,
	2530827,
	2531112,
}

local sounds = {}

--Searches the 'source' table for the 'toFind' item and returns the location index
--of it
function table_search(toFind, source)
local loc = 0;
--print ("Libraries in Source Table: ",table.getn(source))
   for _, v in pairs (source) do
		if (v == toFind) then
			loc = loc + 1
			break
		else
			loc = loc + 1
		end
     end
	 if (loc > 0) then
	 return loc;
	 end
end

--function for listing out the tables, TEST FUNCTION
function list_table(source)
local loc = 0;
print ("Tables in Source Table: ")
   for key, value in pairs(source) do
	print (key)
   end
end

--returns the number of items within a 'source' table, TEST FUNCTION
function active_items(source)
	 return table.getn(source);
end

------------- PANEL SETUP ------------------------------------------------------
-- main panel
local panel = CreateFrame("Frame")
panel.name = addOnName

panel.okay = function(self)
local val = editbox:GetText()
	if tonumber(val) then
	sliderMin, sliderMax = madness_Slider:GetMinMaxValues()
		if (tonumber(val) >= sliderMin and tonumber(val) <= sliderMax) then
			madness_Slider:SetValue(val)
			madness_Timer = val;
			editbox:ClearFocus()
		end
	else
		editbox:ClearFocus()
	end
end

panel.default = function(self)
	madness_Timer = 120;
	madness_Slider:SetValue(madness_Timer)
	editbox:ClearFocus()
	madness_whisperStates.yoggState = true;
	madness_whisperStates.cthunState = true;
	madness_whisperStates.yshaarjState = true;
	madness_whisperStates.voidState = true;
	madness_whisperStates.xalatathstate = true;
	yoggButton:SetChecked(madness_whisperStates.yoggState)
	cThunButton:SetChecked(madness_whisperStates.cthunState)
	yShaarjButton:SetChecked(madness_whisperStates.yshaarjState)
	whispersButton:SetChecked(madness_whisperStates.voidState)
	xalatathButton:SetChecked(madness_whisperStates.xalatathstate)
end
InterfaceOptions_AddCategory(panel)


-- adds in the title of the addon
local title = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetTextColor(.57, .15, .94)
title:SetPoint("CENTER", 0, 250)
title:SetText(addOnName)

--first flavor text
local firsttext = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
firsttext:SetPoint("CENTER", title, "CENTER", 0, -15)
firsttext:SetText("... The Void sees all possible futures ...")
firsttext:SetTextColor(.137, .70, .655)

--second flavor text, under first
local secondtext = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
secondtext:SetPoint("CENTER", firsttext, "CENTER", 0, -15)
secondtext:SetText("... And believes them all to be true ...")
secondtext:SetTextColor(.137, .70, .655)

-- Adds in the header for the voices section
local voices = panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
voices:SetPoint("TOPLEFT", 16, -94)
voices:SetText("Voices of the Old Gods")

--Setting up Buttons

--IF THE SAVE VARIABLE DOES NOT EXIST, CREATES IT (HOLDS THE BOOLEANS FOR BUTTON STATES)
if not madness_whisperStates then
	madness_whisperStates = {}
end

--onLoad function loads after the addon has fully loaded, loads in the SaveVariables and calls the initalize to populate the library
local function onLoad(_, event, arg1)
	if (event == "ADDON_LOADED") then
			--print ("Something atleast happened")
		if madness_whisperStates.yoggState == nil then
			--buttonStates.yoggState = true
			print ("Error with addon Madness of the Void")
		else
			--print ("yoggState: ", madness_whisperStates.yoggState)
		end
		if madness_whisperStates.cthunState == nil then
			print ("Error with addon Madness of the Void")
		else
			--print ("cthunState: ", madness_whisperStates.cthunState)
		end
		if madness_whisperStates.yshaarjState == nil then
			print ("Error with addon Madness of the Void")
		else
			--print ("cthunState: ", madness_whisperStates.yshaarjState)
		end
		if madness_whisperStates.voidState == nil then
			print ("Error with addon Madness of the Void")
		else
			--print ("cthunState: ", madness_whisperStates.voidState)
		end
		if madness_whisperStates.xalatathstate == nil then
			print ("Error with addon Madness of the Void")
		else
			--print ("cthunState: ", madness_whisperStates.voidState)
		end
		yoggButton:SetChecked(madness_whisperStates.yoggState)
		cThunButton:SetChecked(madness_whisperStates.cthunState)
		yShaarjButton:SetChecked(madness_whisperStates.yshaarjState)
		whispersButton:SetChecked(madness_whisperStates.voidState)
		xalatathButton:SetChecked(madness_whisperStates.xalatathstate)
		initSounds()
		madness_Slider:SetValue(madness_Timer)
		editbox:SetCursorPosition(0)
		panel:UnregisterEvent(event)
	else
		--print (arg1)
	end
end

panel:RegisterEvent("ADDON_LOADED")
panel:SetScript("OnEvent", onLoad)

	--Yogg Saron Button
yoggButton = CreateFrame("CheckButton", "yoggButton_GlobalName", panel, "ChatConfigCheckButtonTemplate");
yoggButton:SetPoint("TOPLEFT", voices, "BOTTOMLEFT", 12, -12);
yoggButton_GlobalNameText:SetText(" Madness of Yogg Saron");
yoggButton.tooltip = "Check to enable the voices of Yogg Saron (Checked by Default)";
yoggButton:SetScript("OnClick",
  function(self)
			local checker = yoggButton:GetChecked()
			if checker then
				PlaySound(856) -- Check Click Sound
				table.insert(sounds, yoggSounds)
				madness_whisperStates.yoggState = yoggButton:GetChecked()
				--print ("yoggState: ", madness_whisperStates.yoggState)
			else
				PlaySound(857) -- Check Unclick Sound
				--print("toFind Table at Index: ",table_search(yoggSounds, sounds))
				table.remove(sounds, tonumber(table_search(yoggSounds, sounds)))
				madness_whisperStates.yoggState = yoggButton:GetChecked()
				--print ("yoggState: ", madness_whisperStates.yoggState)
			end
	end);



	--C'Thun Button
cThunButton = CreateFrame("CheckButton", "cThunButton_GlobalName", panel, "ChatConfigCheckButtonTemplate");
cThunButton:SetPoint("TOPLEFT", yoggButton, "BOTTOMLEFT", 0, -12);
cThunButton_GlobalNameText:SetText(" Madness of C'Thun");
cThunButton.tooltip = "Check to enable the voices of C'Thun (Checked by Default)";
cThunButton:SetChecked(true);
cThunButton:SetScript("OnClick",
  function(self)
  			local checker = cThunButton:GetChecked()
			if checker then
				PlaySound(856) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON
				table.insert(sounds, CThunSounds)
				madness_whisperStates.cthunState = cThunButton:GetChecked()
				--print ("cthunState: ", madness_whisperStates.cthunState)
			else
				PlaySound(857) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF
				--print("toFind Table at Index: ",table_search(CThunSounds, sounds))
				table.remove(sounds, tonumber(table_search(CThunSounds, sounds)))
				madness_whisperStates.cthunState = cThunButton:GetChecked()
				--print ("cthunState: ", madness_whisperStates.cthunState)
			end
  end
);


	--Y'Shaarj Button
yShaarjButton = CreateFrame("CheckButton", "yShaarjButton_GlobalName", panel, "ChatConfigCheckButtonTemplate");
yShaarjButton:SetPoint("TOPLEFT", cThunButton, "BOTTOMLEFT", 0, -12);
yShaarjButton_GlobalNameText:SetText(" Madness of Y'Shaarj");
yShaarjButton.tooltip = "Check to enable the voices of Y'Shaarj (Checked by Default)";
yShaarjButton:SetChecked(true);
yShaarjButton:SetScript("OnClick",
  function(self)
  			local checker = yShaarjButton:GetChecked()
			if checker then
				PlaySound(856) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON
				table.insert(sounds, yShaarjsounds)
				madness_whisperStates.yshaarjState = yShaarjButton:GetChecked()
				--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
			else
				PlaySound(857) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF
				--print("toFind Table at Index: ",table_search(yShaarjsounds, sounds))
				table.remove(sounds, tonumber(table_search(yShaarjsounds, sounds)))
				madness_whisperStates.yshaarjState = yShaarjButton:GetChecked()
				--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
			end
  end
);

	--Whispers of the Void Button
whispersButton = CreateFrame("CheckButton", "whispersButton_GlobalName", panel, "ChatConfigCheckButtonTemplate");
whispersButton:SetPoint("TOPLEFT", yShaarjButton, "BOTTOMLEFT", 0, -12);
whispersButton_GlobalNameText:SetText(" Whispers of the Void");
whispersButton.tooltip = "Check to enable additional void audio (Checked by Default)";
whispersButton:SetChecked(true);
whispersButton:SetScript("OnClick",
  function(self)
  			local checker = whispersButton:GetChecked()
			if checker then
				PlaySound(856) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON
				table.insert(sounds, voidSounds)
				madness_whisperStates.voidState = whispersButton:GetChecked()
				--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
			else
				PlaySound(857) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF
				table.remove(sounds, tonumber(table_search(voidSounds, sounds)))
				madness_whisperStates.voidState = whispersButton:GetChecked()
				--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
			end
  end
);

--Xal'atath Whispers Button
xalatathButton = CreateFrame("CheckButton", "xalatathButton_GlobalName", panel, "ChatConfigCheckButtonTemplate");
xalatathButton:SetPoint("TOPLEFT", whispersButton, "BOTTOMLEFT", 0, -12);
xalatathButton_GlobalNameText:SetText(" Madness of Xal'atath");
xalatathButton.tooltip = "Check to enable the voices of Xal'atath (Checked by Default)";
xalatathButton:SetChecked(true);
xalatathButton:SetScript("OnClick",
function(self)
			local checker = xalatathButton:GetChecked()
		if checker then
			PlaySound(856) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_ON
			table.insert(sounds, XalatathSounds)
			madness_whisperStates.xalatathstate = xalatathButton:GetChecked()
			--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
		else
			PlaySound(857) -- SOUNDKIT.IG_MAINMENU_OPTION_CHECKBOX_OFF
			table.remove(sounds, tonumber(table_search(XalatathSounds, sounds)))
			madness_whisperStates.xalatathstate = xalatathButton:GetChecked()
			--print ("yshaarjState: ", madness_whisperStates.yshaarjState)
		end
end
);

	--Create text for the slider
local madness_Timertext = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightMedium")
madness_Timertext:SetPoint("BOTTOMLEFT", 30, 250)
madness_Timertext:SetText("Madness Timer (seconds): ")
madness_Timertext:SetTextColor(.130, .70, .655)

	--Creating the Slider for the madness_Timer
 madness_Slider = CreateFrame("Slider", "madness_SliderGlobalName", panel, "OptionsSliderTemplate")
 madness_Slider:SetWidth(175)
 madness_Slider:SetHeight(20)
 madness_Slider:SetOrientation('HORIZONTAL')
 madness_Slider:SetPoint("CENTER", madness_Timertext, 190, 0);
 madness_Slider.tooltipText = 'Set the timer for audio playback' --Creates a tooltip on mouseover.
 getglobal(madness_Slider:GetName() .. 'Low'):SetText('10'); --Sets the left-side slider text
 getglobal(madness_Slider:GetName() .. 'High'):SetText('1800'); --Sets the right-side slider text
 madness_Slider:SetValueStep(1)
 madness_Slider:SetMinMaxValues(10, 1800)
 madness_Slider:SetObeyStepOnDrag(obeyStep)
 madness_Slider:SetValue(120)

	--Creating editbox to show number for the slider
 editbox = CreateFrame("EditBox", "InputBoxTemplateTest", panel, "InputBoxTemplate")
 editbox:ClearAllPoints()
 editbox:ClearFocus()
 editbox:SetSize(70, 30)
 editbox:SetPoint("LEFT", madness_Slider, "RIGHT", 15, 0)
 editbox:SetText(madness_Slider:GetValue())
 editbox:SetAutoFocus(false)
 editbox:SetCursorPosition(0)

 --Scripts for changing the Slider Values and text box values

	--Slider <- Edit Box
 madness_Slider:SetScript("OnValueChanged", function(self, value)
	madness_Timer = (floor(value))
	editbox:SetText(floor(value))
	end)

	--Edit Box -> Slider
 editbox:SetScript("OnEnterPressed", function(self)
	local val = self:GetText()
	if tonumber(val) then
	sliderMin, sliderMax = madness_Slider:GetMinMaxValues()
		if (tonumber(val) >= sliderMin and tonumber(val) <= sliderMax) then
			madness_Slider:SetValue(val)
			madness_Timer = val;
			self:ClearFocus()
		end
	else
		self:ClearFocus()
	end
end)



-- POPULATE AUDIO LIBRARY ON INITIAL ------------------------------------------------------
function initSounds()
	if (yoggButton:GetChecked(true)) then
	table.insert(sounds, yoggSounds)
	end
	if (cThunButton:GetChecked(true)) then
	table.insert(sounds, CThunSounds)
	end
	if (yShaarjButton:GetChecked(true)) then
	table.insert(sounds, yShaarjsounds)
	end
	if (whispersButton:GetChecked(true)) then
	table.insert(sounds, voidSounds)
	end
	if (xalatathButton:GetChecked(true)) then
	table.insert(sounds, XalatathSounds)
	end
end


	-- TEST LINES FOR LIBRARY TRACKING ------------------------------------------------------
--local TableSize = panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
--TableSize:SetPoint("CENTER", secondtext, "CENTER", 0, -15)
--TableSize:SetText("Active Libraries: " .. table.getn(sounds))

--function update_testLine()
--TableSize:SetText("Active Libraries: " .. tonumber(active_items(sounds)))
--end

------------- AUDIO PLAYER ------------------------------------------------------
local madnessVoices = CreateFrame("Frame")
local tslu = 0
madnessVoices:SetScript("OnUpdate", function(holder, elapsed)
	tslu = tslu + elapsed
	if tslu > tonumber(madness_Timer) then
		if (table.getn(sounds) > 0) then
			tslu = 0
			selectTable = sounds[math.random(#sounds)]
			--print ("Selected Table Entries: ", tonumber(active_items(selectTable)))
			selectAudio = selectTable[math.random(#selectTable)]
			--print ("Selected Entry: ", selectAudio)
			if (tonumber(selectAudio) ~= nil) then
					PlaySoundFile(selectAudio)
			end
			--update_testLine();
			--list_table(sounds);
			--print("madness_Timer: ", madness_Timer)
		else
			tslu = 0
			--update_testLine();
			--list_table(sounds);
			--print("madness_Timer: ", madness_Timer)
		end
	end
end)
